C================================================
C This function sets the number
C of control variables
C================================================
      SUBROUTINE NUMBMOD( N )
      integer N
      N = 3
      END


C================================================
      SUBROUTINE INITMOD( N, X )

      integer N, I
      REAL    X(N)

      DO I = 1, N
        X(I) = 0.1*I
      END DO

      END


C======================================================================
      subroutine model(n,x,fc)

      integer n
      REAL    x(n)
      REAL    fc

      integer i, im1, ip1

      fc = 0.0
      do i = 1,n
        im1 = 1 + mod( n+i-2, n )
        ip1 = 1 + mod(      i, n )
        fc = fc + (x(ip1) -2*x(i) + x(im1))**2
      end do

      end


C================================================
      SUBROUTINE POSTMOD( N, X, FC, ADX )

      integer N
      REAL    X(N), FC, ADX(N)
      integer I

      PRINT *,'**************************************'
      PRINT *,'***     RESULT OF OPTIMISATION      **'
      PRINT *,'**************************************'
      PRINT 9010, FC
      PRINT 9020
      DO I = 1,N
        PRINT 9030, I, X(I), ADX(I)
      ENDDO
 9010 FORMAT(1X,'The value of the costfunction is : ',E15.9)
 9020 FORMAT(1X,'The optimal parameter values, gradients are :')
 9030 FORMAT(1X,I5,1X,E15.9,1X,E15.9)

      END


C================================================
      SUBROUTINE POSTHES( N, XHESS, EIGVAL, EIGVEC )

      integer N
      REAL    XHESS(N,N), EIGVAL(N), EIGVEC(N,N)

      integer I, J

C===============================================
C print eigenvalues and eigenvectors
C===============================================
      PRINT *
      PRINT *,'   nr   eigenvalue       eigenvector '
      DO J = 1,N
        PRINT '(I5,X,E12.6,A,10(1X,E12.6))'
     $        , J, EIGVAL(J), ' +++ ', (EIGVEC(I,J),I=1,N)
      ENDDO

      END

