C =======================================================================
      subroutine inp
C                              ! Reads in initial values of delt, f and a)
      integer    km   , irechis         , irecobs
      parameter (km=10, irechis=8*(km+1), irecobs=8*2*km)   

      REAL         f    , fn    , s    , w, cost
      common/vars/ f(km), fn(km), s(km), w, cost

      REAL         delt, v    , fo    , a
      integer                                  nm, mkobs
      common/cons/ delt, v(km), fo(km), a(km), nm, mkobs


      write(6,*)
c     write(6,*) ' s/r in called:'
      read(10,909) delt, nm, mkobs
 909  format(f8.0,2i8)
        write(6,*) ' delt=',delt,'  nm=',nm,'  mkobs=',mkobs
      read(10,910)(f(k),k=1,km),(a(j),j=1,km)
 910  format(10f8.0)
        write(6,*)' Initial f(k) and a(k):'
        write(6,911)(f(k),k=1,km),(a(j),j=1,km)
 911    format(1x,10f7.3)
        write(6,*) ' '

      end

c ======================================================================
      subroutine initmod(np, f0)
      implicit none
      integer    km   , irechis         , irecobs
      parameter (km=10, irechis=8*(km+1), irecobs=8*2*km)   

      REAL         f    , fn    , s    , w, cost
      common/vars/ f(km), fn(km), s(km), w, cost

      REAL         delt, v    , fo    , a
      integer                                  nm, mkobs
      common/cons/ delt, v(km), fo(km), a(km), nm, mkobs


      integer np
      REAL  f0(km)

      integer k

      open(unit=10,file='controls.dem',status='OLD',
     1         access='SEQUENTIAL')
c     open(unit=11,file='history.dem',access='DIRECT',recl=rechis,
c    1         status='UNKNOWN')
      open(unit=12,file='obs.dem',access='DIRECT',recl=irecobs,
     1          status='UNKNOWN')

      call inp                      ! Read in delt,nm,mkobs,f(k) at n=0 & a(k)
      do 50 k=1,km                  ! Save model ICs in f0(k)
         f0(k)=f(k)
 50   continue

      end


c ====================================================================
      subroutine numbmod( n )

      integer    km   , irechis         , irecobs
      parameter (km=10, irechis=8*(km+1), irecobs=8*2*km)   

      REAL         f    , fn    , s    , w, cost
      common/vars/ f(km), fn(km), s(km), w, cost

      REAL         delt, v    , fo    , a
      integer                                  nm, mkobs
      common/cons/ delt, v(km), fo(km), a(km), nm, mkobs

      integer n
      n = km
      return 
      end


c ====================================================================
      subroutine postmod(np, f0, fc, fgrad)
      implicit none

      integer    km   , irechis         , irecobs
      parameter (km=10, irechis=8*(km+1), irecobs=8*2*km)   

      REAL         f    , fn    , s    , w, cost
      common/vars/ f(km), fn(km), s(km), w, cost

      REAL         delt, v    , fo    , a
      integer                                  nm, mkobs
      common/cons/ delt, v(km), fo(km), a(km), nm, mkobs

      integer np
      REAL    f0(km)
      REAL    fc
      REAL    fgrad(km)

      integer i

      write(6,*)
      write(6,*)' np=',np,'  cost=',fc,'   F0 follows:'
      write(6,990) (f0(i),i=1,km)
      write(6,*) ' '
      write(6,*) ' Gradient FGRAD follows:'
      write(6,990) (fgrad(i),i=1,km)
 990  format(1x,10f7.3)

c      FC0=FC
c      DELTA = 0.001
c      do 100 i=1,km
c	 f0(i)=f0(i)+DELTA
c         call model( Np, F0, FC )
c         FGRAD(i)=(FC-FC0)/DELTA
c         f0(i)=f0(i)-DELTA
c 100  continue
c      write(6,990) (fgrad(i),i=1,km)

      close(10)
      close(11)

      return
      end



      






