
#ifndef define_h
#define define_h

#include <stdio.h>
#include <string.h>

#ifdef __NEXT__
#  include <sys/malloc.h>
#else
#  include <malloc.h>
#endif


#if defined(__STDC__) || defined(__TURBOC__)
# define Void       void
# ifndef Const
#  define Const     const
# endif
# ifdef M_LINT
#  define PP(x)     ()
#  define PV()	    ()
typedef char *Anyptr;
# else
#  define PP(x)     x
#  define PV()      (void)
typedef void *Anyptr;
# endif

# define Inline

#else
# define Void       void
# ifndef Const
#  define Const
# endif
# define PP(x)      ()
# define PV()       ()
typedef char *Anyptr;

#ifdef __GNUC__
# define Inline     inline
#else
# define Inline
#endif

#endif



#define Char        char

# ifndef Static
#  define Static    static
# endif


#ifndef NULL
# define NULL 0L
#endif

#ifndef true
# define true    1
# define false   0
#endif

typedef unsigned char boolean;

typedef struct {
    Anyptr proc, link;
} _PROCEDURE;

#if defined(_SIZE_T) || defined(__SIZE_T) || defined(__SIZE_T__) || defined(_GCC_SIZE_T)
#else
#define _SIZE_T
typedef unsigned long size_t;
#endif

#ifdef ALPHA
/* this should be defined in malloc.h but it isn't on DEC ALPHA */
extern void       *malloc PP((size_t ));
#endif

#ifdef INTEGER_BYTE
#if (INTEGER_BYTE == 4)
#define FORINT int
#else
#define FORINT long
#endif
#else
#define FORINT long
#endif


#endif
