c ======================================================================
      program dem
C
c  Opens files, calls model and adjoint, then does finite difference
c  test to verify the adjoint:

#include "common.h"

      REAL  F0(km)
      REAL  FGRAD(km)

      open(unit=10,file='controls.dem',status='OLD',
     1         access='SEQUENTIAL')
c      open(unit=11,file='history.dem',access='DIRECT',recl=rechis,
c     1         status='UNKNOWN')
      open(unit=12,file='obs.dem',access='DIRECT',recl=irecobs,
     1          status='UNKNOWN')
      call in
      do 50 i=1,km
         f0(i)=f(i)
 50   continue
      np=km
     
      write(6,*) ' Calling model'
      call model( Np, F0, FC )
      ADFC=1.0
      do 60 i=1,km
         FGRAD(i)=0.0
 60   continue

      call admodel( Np, F0, FC, FGRAD, ADFC)
      write(6,*)' np=',np,'  cost=',fc,'   F0 follows:'
      write(6,990) (f0(i),i=1,km)
      write(6,*) ' '
      write(6,*) ' Gradient FGRAD follows:'
      write(6,990) (fgrad(i),i=1,km)
 990  format(1x,10f7.3)

      FC0=FC
      DELTA = 0.001
      do 100 i=1,km
	 f0(i)=f0(i)+DELTA
         call model( Np, F0, FC )
         FGRAD(i)=(FC-FC0)/DELTA
         f0(i)=f0(i)-DELTA
 100  continue
      write(6,990) (fgrad(i),i=1,km)

      close(10)
      close(11)
      stop 1
      end










