      program readobs
      implicit none
      integer n, k, j

C
c  Reads and prints obs.dem files
c  Files are double precision; compile readobs with -r8 option
c  Parameters in 'common.h' are defined for double precision

#include "common.h"

      open(unit=12,file='obs.dem',access='DIRECT',recl=irecobs,
     1       status='UNKNOWN')
      write(6,*) ' '
      write(6,*) ' DUMP OF DIRECT ACCESS FILE obs.dem:'
      
      do 100 n=1,11 
        read(12,rec=n) 
     1    (fo(k),k=1,km),(v(j),j=1,km)  ! Read in obs fo and weights v
        write(6,*)' n=',n
c        write(6,*)' Observations:'
        write(6,990)(fo(k),k=1,km)
c        write(6,*) ' Weights on model/data misfits:'
        write(6,990)(v(k),k=1,km)
 990    format(1x,10f7.3)
 100  continue
      close(12)    

      end
     
