      SUBROUTINE QGBFUN( MODE, NN, XX, OBJF, OBJGRD
     $                 , NSTATE, IUSER, USER              )
C********************************************************************
C
C input  : MODE    switch
C          NN      amount of parameters
C          XX      array of parameters
C          IUSER   integer array
C
C output : OBJF    value of function
C          OBJGRD  gradients of function
C          NSTATE
C
C********************************************************************
      IMPLICIT NONE

      INTEGER MODE, NN, NSTATE, IUSER(1)
      REAL    XX(NN), OBJGRD(NN), USER(1), OBJF

      INTEGER I
      REAL    ADOBJF

C===============================================
C initialize adjoint variables
C===============================================
      DO I = 1,NN
        OBJGRD(I) = 0.0
      END DO
      ADOBJF = 1.0

C===============================================
C compute gradient and cost function
C===============================================
      CALL ADMODEL( NN, XX, OBJF, OBJGRD, ADOBJF )

      END
