      SUBROUTINE SIMUL( INDIC, NN, XX, OBJF, OBJGRD, IZS, RZS, DZS )
C********************************************************************
C
C input  : INDIC   parameter
C          NN      amount of parameters
C          XX      array of parameters
C
C output : OBJF    value of function
C          OBJGRD  gradients of function
C
C********************************************************************
      IMPLICIT NONE

      INTEGER INDIC, NN, IZS
      REAL    XX(NN), OBJF, OBJGRD(NN), RZS
      DOUBLE PRECISION DZS

      INTEGER I
      REAL    ADOBJF

C==============================================
C adjoint model
C==============================================
      DO I = 1,NN
        OBJGRD(I) = 0.0
      END DO
      ADOBJF = 1.0

      CALL ADMODEL ( NN, XX, OBJF, OBJGRD, ADOBJF )

      END
